#<profile4xi profile = "11" /> 
# -------------------------------------------------------------------------------------------------
#<program4xi program = "fire2100eight4xi.py">
#<abstract4xi abstract = "fires to direction eight and to distance 2100"/>
#<verify4xi verification = "11" target = "verb4xi.py"/>
#<refer4xi reference = "verb4xi.py"/>
#<state4xi status = "ACK4tagging; ACK4moduletesting; NACK4systemtesting; [Rel 7.21]"/>
# -------------------------------------------------------------------------------------------------

# -------------------------------------------------------------------------------------------------
# Public API
# -------------------------------------------------------------------------------------------------
#<interface4xi interface = " 
__all__ = [ 'fire2eight4xi']
#"
#/>


# -------------------------------------------------------------------------------------------------
# Standard Imports                          
# -------------------------------------------------------------------------------------------------
#<standardize4xi standard = "
import os
import sys
import threading                
import _thread
import _winapi
   

import signal
import itertools
import weakref
import logging 

from math import pi
from math import sin
from math import cos 
from math import fabs
#"
#/>

# -------------------------------------------------------------------------------------------------
# DragonXi imports                              
# -------------------------------------------------------------------------------------------------
#<dragonize4xi dragonization = "


from time4xi import time4xi

#"
#/>
       
       
# -------------------------------------------------------------------------------------------------
# SHOT2EIGHT - COORDINATE SIGNS OF SHOOT2EIGHT4XI: (X - ,Y - ,Z -)
# -------------------------------------------------------------------------------------------------    
global shot2eight21004xi


#"
#/>

# -------------------------------------------------------------------------------------------------
# Settings
# -------------------------------------------------------------------------------------------------
#<set4xi setting = "
ack2debug = True
         
shot2eight21004xi = {
                1:'-1009x-1423y-1168z',
                2:'-1012x-380y-1800z',
                3:'-1048x-331y-1789z',
                4:'-1056x-1186y-1373z',
                5:'-107x-377y-2063z',
                6:'-1081x-281y-1778z',
                7:'-1088x-1793y-83z',
                8:'-1089x-1377y-1150z',
                9:'-1127x-1138y-1357z',
                10:'-114x-692y-1979z',
                11:'-1168x-1327y-1132z',
                12:'-1181x-1734y-62z',
                13:'-1195x-1087y-1341z',
                14:'-1243x-1272y-1115z',
                15:'-1260x-1031y-1325z',
                16:'-1271x-1671y-41z',
                17:'-1316x-1213y-1097z',
                18:'-1323x-972y-1308z',
                19:'-133x-390y-2058z',
                20:'-1356x-1602y-20z',
                21:'-1383x-908y-1292z',
                22:'-1386x-1149y-1079z',
                23:'-140x-1405y-1553z',
                24:'-1439x-1529y0z',
                25:'-1440x-841y-1275z',
                26:'-1453x-1081y-1061z',
                27:'-1493x-770y-1258z',
                28:'-1517x-1009y-1043z',
                29:'-151x-1612y-1336z',
                30:'-1543x-696y-1241z',
                31:'-154x-2076y-271z',
                32:'-155x-705y-1972z',
                33:'-1576x-934y-1024z',
                34:'-1589x-619y-1224z',
                35:'-161x-402y-2054z',
                36:'-1631x-539y-1207z',
                37:'-1632x-855y-1006z',
                38:'-1668x-456y-1190z',
                39:'-1684x-772y-988z',
                40:'-1701x-371y-1173z',
                41:'-1730x-283y-1155z',
                42:'-1731x-687y-969z',
                43:'-1754x-193y-1138z',
                44:'-1774x-598y-950z',
                45:'-1812x-507y-932z',
                46:'-1845x-414y-913z',
                47:'-190x-412y-2050z',
                48:'-197x-714y-1964z',
                49:'-20x-308y-2077z',
                50:'-216x-1411y-1539z',
                51:'-221x-419y-2045z',
                52:'-237x-1615y-1320z',
                53:'-240x-722y-1957z',
                54:'-254x-424y-2040z',
                55:'-263x-2068y-251z',
                56:'-285x-726y-1949z',
                57:'-287x-428y-2035z',
                58:'-292x-1413y-1525z',
                59:'-321x-428y-2030z',
                60:'-323x-1614y-1303z',
                61:'-330x-728y-1941z',
                62:'-356x-426y-2025z',
                63:'-370x-1411y-1510z',
                64:'-371x-2053y-230z',
                65:'-377x-727y-1933z',
                66:'-392x-422y-2019z',
                67:'-39x-328y-2073z',
                68:'-411x-1607y-1287z',
                69:'-424x-723y-1925z',
                70:'-428x-415y-2013z',
                71:'-448x-1404y-1495z',
                72:'-45x-2078y-292z',
                73:'-464x-405y-2007z',
                74:'-472x-716y-1916z',
                75:'-479x-2033y-209z',
                76:'-498x-1595y-1270z',
                77:'-4x-288y-2080z',
                78:'-500x-393y-2001z',
                79:'-520x-705y-1908z',
                80:'-526x-1392y-1481z',
                81:'-536x-377y-1994z',
                82:'-569x-692y-1899z',
                83:'-572x-359y-1988z',
                84:'-585x-1579y-1253z',
                85:'-585x-2007y-188z',
                86:'-604x-1376y-1466z',
                87:'-608x-339y-1981z',
                88:'-60x-345y-2070z',
                89:'-617x-675y-1890z',
                90:'-642x-315y-1974z',
                91:'-65x-1395y-1567z',
                92:'-65x-1605y-1352z',
                93:'-665x-655y-1880z',
                94:'-672x-1558y-1236z',
                95:'-676x-289y-1966z',
                96:'-682x-1356y-1450z',
                97:'-690x-1976y-167z',
                98:'-709x-260y-1959z',
                99:'-712x-632y-1871z',
                100:'-740x-228y-1951z',
                101:'-758x-1531y-1219z',
                102:'-759x-1331y-1435z',
                103:'-759x-605y-1861z',
                104:'-770x-193y-1943z',
                105:'-793x-1938y-146z',
                106:'-798x-157y-1935z',
                107:'-79x-710y-2080z',
                108:'-805x-576y-1851z',
                109:'-824x-117y-1927z',
                110:'-82x-362y-2066z',
                111:'-835x-1301y-1420z',
                112:'-843x-1500y-1202z',
                113:'-849x-543y-1841z',
                114:'-849x-76y-1919z',
                115:'-893x-506y-1831z',
                116:'-894x-1895y-125z',
                117:'-910x-1267y-1404z',
                118:'-927x-1464y-1185z',
                119:'-934x-467y-1821z',
                120:'-974x-425y-1810z',
                121:'-984x-1229y-1389z',
                122:'-992x-1847y-104z'}
#"
#/>


# -------------------------------------------------------------------------------------------------
#<function4xi function = "fire2100eight4xi" usage = "target function for charge2100eight4xi with Process4Xi">
#<state4xi status = "ACK4tagging; ACK4moduletesting; NACK4systemtesting"/>
# -------------------------------------------------------------------------------------------------
def fire2100eight4xi(queue2eight, consumer_channel2eight, publisher_channel2eight):
    '''
    returns (x,y,z) coordinates via queue
    '''
    
    # -------------------------------------------------------------------------------------------------
    # PARAMETERS                   
    # -------------------------------------------------------------------------------------------------                                                               
    
    time2start = time4xi()
    if ack2debug is True:
        print("\n (STEP 1A1/33) OF FIRE2100EIGHT4XI - STARTED TIME: ", time2start)
        # 
        
        print("\n (STEP 1A2/33) OF FIRE2100EIGHT4XI -  QUEUE2EIGHT: ", queue2eight)      
        # 
        
        print("\n (STEP 1A3/33) OF FIRE2100EIGHT4XI -  CONSUMER_CHANNEL2EIGHT: ", consumer_channel2eight)
        # 
              
        print("\n (STEP 1A4/33) OF FIRE2100EIGHT4XI -  PUBLISHER_CHANNEL2EIGHT: ", publisher_channel2eight)          
        # 
        


    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    # QUEUE RETURNING
    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    ack2put = False
    if ack2debug is True:
        print("\n (STEP 2A/33) OF FIRE2100EIGHT4XI - TRYING TO RETURN BY PUTTING COORDINATE DICTIONARY TO QUEUE2EIGHT: ", queue2eight, " - TIME: ", time4xi()) 
        # 
         
    try:
        # ------------------------------------------------------------------------------------- 
        # PUT SHOT TO QUEUE 
        # -------------------------------------------------------------------------------------                 
        queue2eight.put(shot2eight21004xi)
        if ack2debug is True:
            print("\n (STEP 2B/33) OF FIRE2100EIGHT4XI - SUCCEEDED TO PUT COORDINATE DICTIONARY TO QUEUE2EIGHT: ", queue2eight, " - TIME: ", time4xi()) 
            # 
             
        ack2put = True
    except:
        print("\n (STEP 2C/33) OF FIRE2100EIGHT4XI *** FAILED TO PUT COORDINATE DICTIONARY TO QUEUE2EIGHT: ", queue2eight, " - TIME: ", time4xi()) 
    
    if ack2debug is True:
        print("\n (STEP 3A/33) OF FIRE2100EIGHT4XI - TRYING TO INFORM PUT OPERATIONS VIA PIPE'S PUBLISHER_CHANNEL2EIGHT: ", publisher_channel2eight, " - TIME: ", time4xi())
        # 
         
    try:                
        # ---------------------------------------------------------------------------------------------
        # INFORM PUT OPERATIONS VIA PIPE'S PUBLISHER CHANNEL 
        # ---------------------------------------------------------------------------------------------
        if ack2put is True:
            message2send4one = "<ack2put4xi>queue2eight8shot2eight21004xi</ack2put4xi>"
        else:
            message2send4one = "<nack2put4xi>queue2eight8shot2eight21004xi</nack2put4xi>" 
            
        publisher_channel2eight.send(message2send4one)
        if ack2debug is True:    
            print(" (STEP 3B/33) OF FIRE2100EIGHT4XI -  SENT MESSAGE2SEND4ONE: ", message2send4one, " TO PUBLISHER_CHANNEL2EIGHT: ", publisher_channel2eight, " - TIME: ", time4xi()) 
            #  
        
    except:
        print(" (STEP 3C/33) OF FIRE2100EIGHT4XI *** FAILED TO SEND MESSAGE2SEND4ONE: ", message2send4one, " TO PUBLISHER_CHANNEL2EIGHT: ", publisher_channel2eight, " - TIME: ", time4xi()) 
    
    if ack2debug is True:        
        print("\n (STEP 3D/33) OF FIRE2100EIGHT4XI - RETURNING QUEUE OBJECT QUEUE2EIGHT: ", queue2eight, " - TIME: ", time4xi())  
        # 
            
    return queue2eight    
        
           
#</function4xi>


#</program4xi>
# -------------------------------------------------------------------------------------------------
# Recorded History                             
# ------------------------------------------------------------------------------------------------- 
#<record4xi record = "
#   test_verb4xi.txt
#   sense-test-verb4xi.xml
#   reason-test-verb4xi.xml
#   ace-test-verb4xi.xml
#"
#>

# -------------------------------------------------------------------------------------------------
# Legal Notice                             
# ------------------------------------------------------------------------------------------------- 
#<protect4xi protection = "copyright"
#   owner = "Small & Smart"
#   rights = "All rights reserved"
#   state = "California"
#   country = "United States of America"
#   references = "Legal notice at www.dragonxi.com; www.yourdragonxi.com; www.yourdragonxi.org; www.dragon2xi.com/; www.dragon4xi.com/; www.dragon8xi.com/ " 
#   codes = "Codes established in California and applicable to corporations in California"
#   compliance = "The California Law"
#   court = "Supreme Court of California, 350 McAllister Street, San Francisco, CA 94102-4783"
#/>

#<end4xi end = "
# -------------------------------------------------------------------------------------------------
# end of fire2100eight4xi.py                             
# ------------------------------------------------------------------------------------------------- 
#"
#/>
                                  